require('./overrides.js'); // global overrides...

function Bentheim(options) {
    this._log = require('log4js').getLogger('customer.bentheim');
    this._log.setLevel('INFO');

    this._intialize();
}

Bentheim.prototype._intialize = function(options) {
    this._log.info('Customer Bentheim');
}

Bentheim.prototype.registerExpress = function(app) {
    var express = require("express"); // start express

    app.use(express.static("customer.bentheim/public")); // set directory

}

Bentheim.prototype.registerExpressRoutes = function(app) {
    app.post('/bentheim-upload-targetface', function(req, res) {
        // var dataUrl = req.body.img;
        // var matches = dataUrl.match(/^data:.+\/(.+);base64,(.*)$/);
        // var buffer = new Buffer(matches[2], 'base64');
    
        // bentheim_save_image(buffer, req.body.stringId, function() {
        //     res.json({});
        // });
        // var fs = require('fs');
        // var base64Data = req.body.img.replace(/^data:image\/png;base64,/, "");
        // fs.writeFile(`./${req.body.stringId}.png`, base64Data, 'base64', function(err) {
        //     if (err) {
        //        console.log(err);
        //     }
        //     res.json({});
        // });
        res.json({});
    });
    app.get('/bentheim-test', function(req, res) {
        res.json({ test: 'OK' });
    });
    app.get('/bentheim-targetface/:id', function(req, res) {
        bentheim_load_image(req.params.id, function(data) {
            res.writeHead(200, [['Content-Type', 'image/png']]);
            res.end(new Buffer(data, 'base64'));
        });
    });
}

Bentheim.prototype.getGlobalOverrides = function() {
    return [
        './customer.bentheim/overrides.js'
    ];
}

module.exports = Bentheim;